<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2006 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.4
  $Source: /cvsroot/coppermine/stable/upload.php,v $
  $Revision: 1.21 $
  $Author: gaugau $
  $Date: 2006/02/24 13:30:07 $
  ********************************************
  Coppermine version: ?
  $Source: /cvsroot/coppermine/stable/jupload.php,v $
  $Revision: ?
  $Author: Etienne Gauthier
  $Date: ?
**********************************************/



if (!defined('IN_COPPERMINE')) {
	//There can be direct access to this URL: as Coppermine central scripts (ex: login and errors) only
	//redirect to a page, without transmitting its parameters, we redirect to the plugins/jupload/jupload.php
	//Now that we are here, we redirect to  YourCoppermineInstallation/index.php?file=jupload/jupload
	
	//test url: http://localhost/coppermine/plugins/jupload/jupload.php?toto=qssqgh
	
	//Let's get all GET parameters in this query, and redirect to the correct URL.
	$parameters = '';
	foreach ($_GET as $param => $value) {
		$parameters .= '&' . urlencode($param) . '=' . urlencode($value);
	}
	echo <<<EOS
	<script language="javascript">
	document.location.replace("../../index.php?file=jupload/jupload${parameters}"); 
	</script>
EOS;
	exit;	
}


//####################################################################################################
//#################################     INCLUDES    ##################################################
//####################################################################################################

// Activate more language block sets.
define('UPLOAD_PHP', true);
define('DB_INPUT_PHP', true);
define('ADMIN_PHP', true);
define('EDITPICS_PHP', true);
//Langages for the album and categories management.
define('ALBMGR_PHP', true); // added this line as workaround for missing translation of *no category*. Should be removed in next version. GauGau 2005-08-09
define('CATMGR_PHP', true);


// Call basic functions, etc.
require_once('include/init.inc.php');
//require_once('include/picmgmt.inc.php');
require_once('plugins/jupload/include/gui.inc.php');

//Let's also include the main jupload include file.
define('JUPLOAD_PHP', true);
require('plugins/jupload/include/jupload.inc.php');

// Some placeholders.
$customize = CUSTOMIZE_UPLOAD_FORM;
$user_form = USER_UPLOAD_FORM;
$allowed_URI_boxes = NUM_URI_BOXES;
$allowed_file_boxes = NUM_FILE_BOXES;

// Check to see if user can upload pictures.  Quit with an error if he cannot.
if (!USER_CAN_UPLOAD_PICTURES) {
    //cpg_die(ERROR, $lang_jupload_php['perm_denied'], __FILE__, __LINE__);
    //redirection to Coppermine/plugins/jupload, so that the login page can redirect to the
    //plugin. See the if (!defined('IN_COPPERMINE')) {, at the beginning of the script
    cpg_die(
    	ERROR, 
    	str_replace(
			'$1', 
			'login.php?referer=plugins/jupload/jupload.php', 
			$lang_jupload_php['perm_denied']),
		__FILE__, 
		__LINE__);    
}

// Globalize $CONFIG.
global $CONFIG, $lang_jupload_php, $user_form, $max_file_size;


//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################



//####################################################################################################
//#############################  INIT OF SCRIPT VARIABLES  ###########################################
//####################################################################################################

//Initialize local parameters.
$action				= isset($_POST['action']			) ? $_POST['action'] 			: $_GET['action'];

$category			= isset($_POST['category']			) ? ( (int) $_POST['category'])	: (isset($_GET['category'])?(int)$_GET['category']:0);
if ($category==0) {
	$current_category 	= array('cid' => '0', 'name' => '', 'parent' => '0', 'description' => '');
} else {
	$result = cpg_db_query("SELECT cid, name, parent, description FROM {$CONFIG['TABLE_CATEGORIES']} WHERE cid = '$category' LIMIT 1");
	$current_category = mysql_fetch_array($result);
}

$album				= isset($_POST['album']				) ? ( (int) $_POST['album']) 	: (isset($_GET['album'])?(int)$_GET['album']:0);
$album_name			= isset($_POST['album_name']		) ? $_POST['album_name'] 		: '';
$album_description	= isset($_POST['album_description'] ) ? $_POST['album_description'] : '';
if (isset($_GET['jupart']) && isset($_GET['jufinal'])) {
	$chunkedUpload = true;
	$jupart  = (int) $_GET['jupart'];
	$jufinal = (int) $_GET['jufinal'];
} else {
	$chunkedUpload = false;
}

$JUPLOAD_VAR['SELF'] = 'index.php?file=jupload/jupload'
	. ( $album>0 ? "&album=$album" : '')	
	. ( $category>0 ? "&category=$category" : '')	
;
// Get public and private albums, and set maximum individual file size.

if (GALLERY_ADMIN_MODE) {
    $public_albums = cpg_db_query("SELECT aid, title, description  FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " ORDER BY title");
} else {
	$public_albums = cpg_db_query("SELECT aid, title, description  FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " AND uploads='YES' AND (visibility = '0' OR visibility IN ".USER_GROUP_SET.") ORDER BY title");
}
if (mysql_num_rows($public_albums)) {
    $public_albums_list = cpg_db_fetch_rowset($public_albums);
} else {
    $public_albums_list = array();
}

if (USER_ID) {
    $user_albums = cpg_db_query("SELECT aid, title, description FROM {$CONFIG['TABLE_ALBUMS']} WHERE category='" . (FIRST_USER_CAT + USER_ID) . "' ORDER BY title");
    if (mysql_num_rows($user_albums)) {
        $user_albums_list = cpg_db_fetch_rowset($user_albums);
    } else {
        $user_albums_list = array();
    }
} else {
    $user_albums_list = array();
}

/*
if (!count($public_albums_list) && !count($user_albums_list)) {
    cpg_die (ERROR, $lang_upload_php['err_no_alb_uploadables'], __FILE__, __LINE__);
}
*/

// Assign maximum file size for browser crontrols.
//$max_file_size = $CONFIG['max_upl_size'] << 10;



if ($album_name == ''  && $album > 0) {
	//Let's get the album name and description for the selected album. 
	$found = false;
    foreach($user_albums_list as $a) {
    	if ($a['aid'] == $album) {
    		$found = true;
    		$album_name = $a['title'];
    		$album_description = $a['description'];
    	}
    }
    if (!$found) {
	    foreach($public_albums_list as $a) {
	    	if ($a['aid'] == $album) {
	    		$found = true;
	    		$album_name = $a['title'];
	    		$album_description = $a['description'];
	    	}
	    }
    }
}


//####################################################################################################
//################################# MAIN CODE BLOCK ##################################################
//####################################################################################################


///////////////////////////////////////////////////////////////////////
/////////////////   HANDLE OF INCOMING ACTIONS  (if any)  /////////////
///////////////////////////////////////////////////////////////////////


switch ($action) {
//First: generation of the standard jupload page, containing the applet:
case 'update_album':
case 'create_album':
case 'upload_page':
case '':
	require("page/upload_page.php");
	break;
//Upload of a picture from the applet. No HTML to generate.
case 'add_picture':
	require("page/upload_picture.php");
	break;
//Edition of the properties of the uploaded pictures:
case 'edit_uploaded_pics':
	require("page/edit_uploaded_pics.php");
	break;
case 'config':
case 'store_config':
	require("page/config_page.php");
	break;
case 'log_error':
	require("page/log_error.php");
	break;
case 'display_error':
	$text = $_GET['text'];
	$msg = $lang_jupload_php[$text];
	cpg_die(ERROR, $msg, __FILE__, __LINE__);
default:
	cpg_die (ERROR, 'JUpload: Unknown action value', __FILE__, __LINE__);
}

